/*
 * IBM Technical Support Appliance Version 2 Release 0 Modification 0
 *
 * (C) Copyright IBM Corp. 2017
 */

define(
  [ 'jquery'
  , 'tsa/TypeVerificator'
  ],
  
  function( $
          , TV
          )
  {
    /**
     * This module is not a constructor, but a set of functions.
     */
    tsa.data.Countries = {};
    
    /**
     * The data, as an array, sorted by the country name in English.
     * @private
     * @type {Array.<Object>}
     */
    tsa.data.Countries._data =
    [   { id : 'AF' , name : { en : 'AFGHANISTAN' } }
      , { id : 'AX' , name : { en : '\u00C5LAND ISLANDS' } }
      , { id : 'AL' , name : { en : 'ALBANIA' } }
      , { id : 'DZ' , name : { en : 'ALGERIA' } }
      , { id : 'AS' , name : { en : 'AMERICAN SAMOA' } }
      , { id : 'AD' , name : { en : 'ANDORRA' } }
      , { id : 'AO' , name : { en : 'ANGOLA' } }
      , { id : 'AI' , name : { en : 'ANGUILLA' } }
      , { id : 'AQ' , name : { en : 'ANTARCTICA' } }
      , { id : 'AG' , name : { en : 'ANTIGUA AND BARBUDA' } }
      , { id : 'AR' , name : { en : 'ARGENTINA' } }
      , { id : 'AM' , name : { en : 'ARMENIA' } }
      , { id : 'AW' , name : { en : 'ARUBA' } }
      , { id : 'AU' , name : { en : 'AUSTRALIA' } }
      , { id : 'AT' , name : { en : 'AUSTRIA' } }
      , { id : 'AZ' , name : { en : 'AZERBAIJAN' } }
      , { id : 'BS' , name : { en : 'BAHAMAS' } }
      , { id : 'BH' , name : { en : 'BAHRAIN' } }
      , { id : 'BD' , name : { en : 'BANGLADESH' } }
      , { id : 'BB' , name : { en : 'BARBADOS' } }
      , { id : 'BY' , name : { en : 'BELARUS' } }
      , { id : 'BE' , name : { en : 'BELGIUM' } }
      , { id : 'BZ' , name : { en : 'BELIZE' } }
      , { id : 'BJ' , name : { en : 'BENIN' } }
      , { id : 'BM' , name : { en : 'BERMUDA' } }
      , { id : 'BT' , name : { en : 'BHUTAN' } }
      , { id : 'BO' , name : { en : 'BOLIVIA' } }
      , { id : 'BA' , name : { en : 'BOSNIA AND HERZEGOVINA' } }
      , { id : 'BW' , name : { en : 'BOTSWANA' } }
      , { id : 'BV' , name : { en : 'BOUVET ISLAND' } }
      , { id : 'BR' , name : { en : 'BRAZIL' } }
      , { id : 'IO' , name : { en : 'BRITISH INDIAN OCEAN TERRITORY' } }
      , { id : 'BN' , name : { en : 'BRUNEI DARUSSALAM' } }
      , { id : 'BG' , name : { en : 'BULGARIA' } }
      , { id : 'BF' , name : { en : 'BURKINA FASO' } }
      , { id : 'BI' , name : { en : 'BURUNDI' } }
      , { id : 'KH' , name : { en : 'CAMBODIA' } }
      , { id : 'CM' , name : { en : 'CAMEROON' } }
      , { id : 'CA' , name : { en : 'CANADA' } }
      , { id : 'CV' , name : { en : 'CAPE VERDE' } }
      , { id : 'KY' , name : { en : 'CAYMAN ISLANDS' } }
      , { id : 'CF' , name : { en : 'CENTRAL AFRICAN REPUBLIC' } }
      , { id : 'TD' , name : { en : 'CHAD' } }
      , { id : 'CL' , name : { en : 'CHILE' } }
      , { id : 'CN' , name : { en : 'CHINA' } }
      , { id : 'CX' , name : { en : 'CHRISTMAS ISLAND' } }
      , { id : 'CC' , name : { en : 'COCOS (KEELING) ISLANDS' } }
      , { id : 'CO' , name : { en : 'COLOMBIA' } }
      , { id : 'KM' , name : { en : 'COMOROS' } }
      , { id : 'CG' , name : { en : 'CONGO' } }
      , { id : 'CD' , name : { en : 'CONGO, THE DEMOCRATIC REPUBLIC OF THE' } }
      , { id : 'CK' , name : { en : 'COOK ISLANDS' } }
      , { id : 'CR' , name : { en : 'COSTA RICA' } }
      , { id : 'CI' , name : { en : 'COTE D\'IVOIRE' } }
      , { id : 'HR' , name : { en : 'CROATIA' } }
      , { id : 'CU' , name : { en : 'CUBA' } }
      , { id : 'CY' , name : { en : 'CYPRUS' } }
      , { id : 'CZ' , name : { en : 'CZECH REPUBLIC' } }
      , { id : 'DK' , name : { en : 'DENMARK' } }
      , { id : 'DJ' , name : { en : 'DJIBOUTI' } }
      , { id : 'DM' , name : { en : 'DOMINICA' } }
      , { id : 'DO' , name : { en : 'DOMINICAN REPUBLIC' } }
      , { id : 'EC' , name : { en : 'ECUADOR' } }
      , { id : 'EG' , name : { en : 'EGYPT' } }
      , { id : 'SV' , name : { en : 'EL SALVADOR' } }
      , { id : 'GQ' , name : { en : 'EQUATORIAL GUINEA' } }
      , { id : 'ER' , name : { en : 'ERITREA' } }
      , { id : 'EE' , name : { en : 'ESTONIA' } }
      , { id : 'ET' , name : { en : 'ETHIOPIA' } }
      , { id : 'FK' , name : { en : 'FALKLAND ISLANDS (MALVINAS)' } }
      , { id : 'FO' , name : { en : 'FAROE ISLANDS' } }
      , { id : 'FJ' , name : { en : 'FIJI' } }
      , { id : 'FI' , name : { en : 'FINLAND' } }
      , { id : 'FR' , name : { en : 'FRANCE' } }
      , { id : 'GF' , name : { en : 'FRENCH GUIANA' } }
      , { id : 'PF' , name : { en : 'FRENCH POLYNESIA' } }
      , { id : 'TF' , name : { en : 'FRENCH SOUTHERN TERRITORIES' } }
      , { id : 'GA' , name : { en : 'GABON' } }
      , { id : 'GM' , name : { en : 'GAMBIA' } }
      , { id : 'GE' , name : { en : 'GEORGIA' } }
      , { id : 'DE' , name : { en : 'GERMANY' } }
      , { id : 'GH' , name : { en : 'GHANA' } }
      , { id : 'GI' , name : { en : 'GIBRALTAR' } }
      , { id : 'GR' , name : { en : 'GREECE' } }
      , { id : 'GL' , name : { en : 'GREENLAND' } }
      , { id : 'GD' , name : { en : 'GRENADA' } }
      , { id : 'GP' , name : { en : 'GUADELOUPE' } }
      , { id : 'GU' , name : { en : 'GUAM' } }
      , { id : 'GT' , name : { en : 'GUATEMALA' } }
      , { id : 'GG' , name : { en : 'GUERNSEY' } }
      , { id : 'GN' , name : { en : 'GUINEA' } }
      , { id : 'GW' , name : { en : 'GUINEA-BISSAU' } }
      , { id : 'GY' , name : { en : 'GUYANA' } }
      , { id : 'HT' , name : { en : 'HAITI' } }
      , { id : 'HM' , name : { en : 'HEARD ISLAND AND MCDONALD ISLANDS' } }
      , { id : 'VA' , name : { en : 'HOLY SEE (VATICAN CITY STATE)' } }
      , { id : 'HN' , name : { en : 'HONDURAS' } }
      , { id : 'HK' , name : { en : 'HONG KONG' } }
      , { id : 'HU' , name : { en : 'HUNGARY' } }
      , { id : 'IS' , name : { en : 'ICELAND' } }
      , { id : 'IN' , name : { en : 'INDIA' } }
      , { id : 'ID' , name : { en : 'INDONESIA' } }
      , { id : 'IR' , name : { en : 'IRAN, ISLAMIC REPUBLIC OF' } }
      , { id : 'IQ' , name : { en : 'IRAQ' } }
      , { id : 'IE' , name : { en : 'IRELAND' } }
      , { id : 'IM' , name : { en : 'ISLE OF MAN' } }
      , { id : 'IL' , name : { en : 'ISRAEL' } }
      , { id : 'IT' , name : { en : 'ITALY' } }
      , { id : 'JM' , name : { en : 'JAMAICA' } }
      , { id : 'JP' , name : { en : 'JAPAN' } }
      , { id : 'JE' , name : { en : 'JERSEY' } }
      , { id : 'JO' , name : { en : 'JORDAN' } }
      , { id : 'KZ' , name : { en : 'KAZAKHSTAN' } }
      , { id : 'KE' , name : { en : 'KENYA' } }
      , { id : 'KI' , name : { en : 'KIRIBATI' } }
      , { id : 'KP' , name : { en : 'KOREA, DEMOCRATIC PEOPLE\'S REPUBLIC OF' } }
      , { id : 'KR' , name : { en : 'KOREA, REPUBLIC OF' } }
      , { id : 'KW' , name : { en : 'KUWAIT' } }
      , { id : 'KG' , name : { en : 'KYRGYZSTAN' } }
      , { id : 'LA' , name : { en : 'LAO PEOPLE\'S DEMOCRATIC REPUBLIC' } }
      , { id : 'LV' , name : { en : 'LATVIA' } }
      , { id : 'LB' , name : { en : 'LEBANON' } }
      , { id : 'LS' , name : { en : 'LESOTHO' } }
      , { id : 'LR' , name : { en : 'LIBERIA' } }
      , { id : 'LY' , name : { en : 'LIBYAN ARAB JAMAHIRIYA' } }
      , { id : 'LI' , name : { en : 'LIECHTENSTEIN' } }
      , { id : 'LT' , name : { en : 'LITHUANIA' } }
      , { id : 'LU' , name : { en : 'LUXEMBOURG' } }
      , { id : 'MO' , name : { en : 'MACAO' } }
      , { id : 'MK' , name : { en : 'MACEDONIA, THE FORMER YUGOSLAV REPUBLIC OF' } }
      , { id : 'MG' , name : { en : 'MADAGASCAR' } }
      , { id : 'MW' , name : { en : 'MALAWI' } }
      , { id : 'MY' , name : { en : 'MALAYSIA' } }
      , { id : 'MV' , name : { en : 'MALDIVES' } }
      , { id : 'ML' , name : { en : 'MALI' } }
      , { id : 'MT' , name : { en : 'MALTA' } }
      , { id : 'MH' , name : { en : 'MARSHALL ISLANDS' } }
      , { id : 'MQ' , name : { en : 'MARTINIQUE' } }
      , { id : 'MR' , name : { en : 'MAURITANIA' } }
      , { id : 'MU' , name : { en : 'MAURITIUS' } }
      , { id : 'YT' , name : { en : 'MAYOTTE' } }
      , { id : 'MX' , name : { en : 'MEXICO' } }
      , { id : 'FM' , name : { en : 'MICRONESIA, FEDERATED STATES OF' } }
      , { id : 'MD' , name : { en : 'MOLDOVA, REPUBLIC OF' } }
      , { id : 'MC' , name : { en : 'MONACO' } }
      , { id : 'MN' , name : { en : 'MONGOLIA' } }
      , { id : 'ME' , name : { en : 'MONTENEGRO' } }
      , { id : 'MS' , name : { en : 'MONTSERRAT' } }
      , { id : 'MA' , name : { en : 'MOROCCO' } }
      , { id : 'MZ' , name : { en : 'MOZAMBIQUE' } }
      , { id : 'MM' , name : { en : 'MYANMAR' } }
      , { id : 'NA' , name : { en : 'NAMIBIA' } }
      , { id : 'NR' , name : { en : 'NAURU' } }
      , { id : 'NP' , name : { en : 'NEPAL' } }
      , { id : 'NL' , name : { en : 'NETHERLANDS' } }
      , { id : 'AN' , name : { en : 'NETHERLANDS ANTILLES' } }
      , { id : 'NC' , name : { en : 'NEW CALEDONIA' } }
      , { id : 'NZ' , name : { en : 'NEW ZEALAND' } }
      , { id : 'NI' , name : { en : 'NICARAGUA' } }
      , { id : 'NE' , name : { en : 'NIGER' } }
      , { id : 'NG' , name : { en : 'NIGERIA' } }
      , { id : 'NU' , name : { en : 'NIUE' } }
      , { id : 'NF' , name : { en : 'NORFOLK ISLAND' } }
      , { id : 'MP' , name : { en : 'NORTHERN MARIANA ISLANDS' } }
      , { id : 'NO' , name : { en : 'NORWAY' } }
      , { id : 'OM' , name : { en : 'OMAN' } }
      , { id : 'PK' , name : { en : 'PAKISTAN' } }
      , { id : 'PW' , name : { en : 'PALAU' } }
      , { id : 'PS' , name : { en : 'PALESTINIAN TERRITORY, OCCUPIED' } }
      , { id : 'PA' , name : { en : 'PANAMA' } }
      , { id : 'PG' , name : { en : 'PAPUA NEW GUINEA' } }
      , { id : 'PY' , name : { en : 'PARAGUAY' } }
      , { id : 'PE' , name : { en : 'PERU' } }
      , { id : 'PH' , name : { en : 'PHILIPPINES' } }
      , { id : 'PN' , name : { en : 'PITCAIRN' } }
      , { id : 'PL' , name : { en : 'POLAND' } }
      , { id : 'PT' , name : { en : 'PORTUGAL' } }
      , { id : 'PR' , name : { en : 'PUERTO RICO' } }
      , { id : 'QA' , name : { en : 'QATAR' } }
      , { id : 'RE' , name : { en : 'REUNION' } }
      , { id : 'RO' , name : { en : 'ROMANIA' } }
      , { id : 'RU' , name : { en : 'RUSSIAN FEDERATION' } }
      , { id : 'RW' , name : { en : 'RWANDA' } }
      , { id : 'SH' , name : { en : 'SAINT HELENA' } }
      , { id : 'KN' , name : { en : 'SAINT KITTS AND NEVIS' } }
      , { id : 'LC' , name : { en : 'SAINT LUCIA' } }
      , { id : 'PM' , name : { en : 'SAINT PIERRE AND MIQUELON' } }
      , { id : 'VC' , name : { en : 'SAINT VINCENT AND THE GRENADINES' } }
      , { id : 'WS' , name : { en : 'SAMOA' } }
      , { id : 'SM' , name : { en : 'SAN MARINO' } }
      , { id : 'ST' , name : { en : 'SAO TOME AND PRINCIPE' } }
      , { id : 'SA' , name : { en : 'SAUDI ARABIA' } }
      , { id : 'SN' , name : { en : 'SENEGAL' } }
      , { id : 'RS' , name : { en : 'SERBIA' } }
      , { id : 'SC' , name : { en : 'SEYCHELLES' } }
      , { id : 'SL' , name : { en : 'SIERRA LEONE' } }
      , { id : 'SG' , name : { en : 'SINGAPORE' } }
      , { id : 'SK' , name : { en : 'SLOVAKIA' } }
      , { id : 'SI' , name : { en : 'SLOVENIA' } }
      , { id : 'SB' , name : { en : 'SOLOMON ISLANDS' } }
      , { id : 'SO' , name : { en : 'SOMALIA' } }
      , { id : 'ZA' , name : { en : 'SOUTH AFRICA' } }
      , { id : 'GS' , name : { en : 'SOUTH GEORGIA AND THE SOUTH SANDWICH ISLANDS' } }
      , { id : 'SS' , name : { en : 'SOUTH SUDAN' } }
      , { id : 'ES' , name : { en : 'SPAIN' } }
      , { id : 'LK' , name : { en : 'SRI LANKA' } }
      , { id : 'SD' , name : { en : 'SUDAN' } }
      , { id : 'SR' , name : { en : 'SURINAME' } }
      , { id : 'SJ' , name : { en : 'SVALBARD AND JAN MAYEN' } }
      , { id : 'SZ' , name : { en : 'SWAZILAND' } }
      , { id : 'SE' , name : { en : 'SWEDEN' } }
      , { id : 'CH' , name : { en : 'SWITZERLAND' } }
      , { id : 'SY' , name : { en : 'SYRIAN ARAB REPUBLIC' } }
      , { id : 'TW' , name : { en : 'TAIWAN, PROVINCE OF CHINA' } }
      , { id : 'TJ' , name : { en : 'TAJIKISTAN' } }
      , { id : 'TZ' , name : { en : 'TANZANIA, UNITED REPUBLIC OF' } }
      , { id : 'TH' , name : { en : 'THAILAND' } }
      , { id : 'TL' , name : { en : 'TIMOR-LESTE' } }
      , { id : 'TG' , name : { en : 'TOGO' } }
      , { id : 'TK' , name : { en : 'TOKELAU' } }
      , { id : 'TO' , name : { en : 'TONGA' } }
      , { id : 'TT' , name : { en : 'TRINIDAD AND TOBAGO' } }
      , { id : 'TN' , name : { en : 'TUNISIA' } }
      , { id : 'TR' , name : { en : 'TURKEY' } }
      , { id : 'TM' , name : { en : 'TURKMENISTAN' } }
      , { id : 'TC' , name : { en : 'TURKS AND CAICOS ISLANDS' } }
      , { id : 'TV' , name : { en : 'TUVALU' } }
      , { id : 'UG' , name : { en : 'UGANDA' } }
      , { id : 'UA' , name : { en : 'UKRAINE' } }
      , { id : 'AE' , name : { en : 'UNITED ARAB EMIRATES' } }
      , { id : 'GB' , name : { en : 'UNITED KINGDOM' } }
      , { id : 'US' , name : { en : 'UNITED STATES' } }
      , { id : 'UM' , name : { en : 'UNITED STATES MINOR OUTLYING ISLANDS' } }
      , { id : 'UY' , name : { en : 'URUGUAY' } }
      , { id : 'UZ' , name : { en : 'UZBEKISTAN' } }
      , { id : 'VU' , name : { en : 'VANUATU' } }
      , { id : 'VE' , name : { en : 'VENEZUELA' } }
      , { id : 'VN' , name : { en : 'VIET NAM' } }
      , { id : 'VG' , name : { en : 'VIRGIN ISLANDS, BRITISH' } }
      , { id : 'VI' , name : { en : 'VIRGIN ISLANDS, U.S.' } }
      , { id : 'WF' , name : { en : 'WALLIS AND FUTUNA' } }
      , { id : 'EH' , name : { en : 'WESTERN SAHARA' } }
      , { id : 'YE' , name : { en : 'YEMEN' } }
      , { id : 'ZM' , name : { en : 'ZAMBIA' } }
      , { id : 'ZW' , name : { en : 'ZIMBABWE' } }
    ];
    
    /**
     * The data, as a map (by ID).
     * @private
     * @type {Object.<string,Object>}
     */
    tsa.data.Countries._dataMap = {};
    
    $.each( tsa.data.Countries._data, function( index, country )
    {
      tsa.data.Countries._dataMap[ country.id ] = country;
    } );
    
    /**
     * Access method: get country by ID.
     * @param {string} id The country ID.
     * @return {Object}   The country data, or null if ID is not found.
     */
    tsa.data.Countries.getById = function( id )
    {
      /** @type {Object} */var country = null;
      
      if( TV.typeIsString( typeof id ) )
      {
        if( TV.typeIsObject( typeof tsa.data.Countries._dataMap[ id ] ) )
        {
          country = tsa.data.Countries._dataMap[ id ];
        }
      }
      
      return country;
    };
    
    /**
     * Access method: get countries, sorted by name.
     * @param {string=}         lang The language ID (currently only English is supported: 'en').
     *                               Optional. Default: 'en' (English).
     * @return {Array.<Object>}      The countries data.
     */
    tsa.data.Countries.getCountries = function( lang )
    {
      /** @type {Array.<Object>} */ var result = null;
      
      if( !TV.typeIsString( typeof lang ) )
      {
        lang = 'en';
      }
      
      result = tsa.data.Countries._data.slice();
      
      result.sort( function( countryA, countryB )
      {
        /** @type {number} */ var result = 0;
        
        try
        {
          result = countryA.name[ lang ].localeCompare( countryB.name[ lang ] );
        }
        catch( error ) { /* ignore */ }
        
        return result;
      } );
      
      return result;
    };
    
    return tsa.data.Countries;
  }
);